unit Calc;
 {
          Calc unit
          for SOLDAT

 Copyright  2001 Michal Marcinkowski
 }

interface
uses D3DX8, PolyMap;

  function PointLineDistance(P1,P2,P3 : TD3DXVector2):single;
  function Angle2Points(x1,y1,x2,y2 : single) : single;
  function Distance(x1,y1,x2,y2:single) : single;
  function CharCount(Ch : string; S : string) : integer;

implementation


function PointLineDistance(P1,P2,P3 : TD3DXVector2):single;
var
 U, X, Y : single;
begin
 U:= ((P3.X - P1.X)*(P2.X - P1.X) + (P3.Y - P1.Y)*(P2.Y - P1.Y)) / (sqr(P2.X - P1.X) + sqr(P2.Y - P1.Y));

 X:= P1.X + U*(P2.X - P1.X);
 Y:= P1.Y + U*(P2.Y - P1.Y);

 Result:= sqrt(sqr(X-P3.X)+sqr(Y-P3.Y));
end;

function Angle2Points(x1,y1,x2,y2 : single) : single;
begin
 if ((x2-x1)<>0) then
 begin
 if x1>x2 then
 result:= (ArcTan((y2 - y1) / (x2 - x1)) * Pi / Pi)+Pi
 else result:= (ArcTan((y2 - y1) / (x2 - x1)) * Pi / Pi);
 end else
  begin
   if y2>y1 then result:= Pi/2;
   if y2<y1 then result:= -Pi/2;
  end;
end;

function Distance(x1,y1,x2,y2:single) : single;
begin
 result:= Sqrt((Sqr(x1 - x2)) + (Sqr(y1 - y2)));
end;

function CharCount(Ch : string; S : string) : integer;
var i : integer;
begin
Result:= 0;
 for i:= 1 to length(S) do
  if S[i]=Ch then Result:= Result + 1;
end;

end.
