unit Waypoints;
 {
       Waypoints unit
        for SOLDAT

 Copyright  2002 Michal Marcinkowski
 }
interface

const
 MAX_WAYPOINTS = 5000;
 MAX_CONNECTIONS = 20;

type TNewWaypoint = record
 Active : boolean;
 id : integer;
 X, Y : integer;
 left, right, up, down, m2 : boolean;
 PathNum : byte;
 C1, C2, C3 : byte;
 ConnectionsNum : integer;
 Connections : array[1..MAX_CONNECTIONS] of integer;
end;

type TNewWaypoints = object
 Waypoint : array[1..MAX_WAYPOINTS] of TNewWaypoint;

 function  FindClosest(X,Y : single; Radius, CurrWaypoint : integer):integer;
 function  CreateWayPoint(sX,sY, sPath : integer):integer;
end;


type TWaypoint = record
 Active : boolean;
 id : integer;
 X, Y : integer;
 left, right, up, down, m2 : boolean;
 PathNum : integer;
 ConnectionsNum : integer;
 Connections : array[1..MAX_CONNECTIONS] of integer;
end;

type TWaypoints = object
 Waypoint : array[1..500] of TWaypoint;
end;

  {for file use}
  TPathRec = record
   Waypoint : array[1..500] of TWaypoint;
  end;


implementation
uses Calc;

function TNewWaypoints.FindClosest(X,Y : single; Radius, CurrWaypoint : integer):integer;
var
 d : single;
 i : integer;
begin
 Result:= 0;

 for i:= 1 to MAX_WAYPOINTS do
 if (Waypoint[i].Active)and(CurrWaypoint<>i) then
 begin
  d:= Distance(X,Y,Waypoint[i].X,Waypoint[i].Y);
  if D<Radius then
  begin
   Result:= i;
   exit;
  end;
 end;

end;


function TNewWaypoints.CreateWayPoint(sX,sY, sPath : integer):integer;
var
 i : integer;
begin
 for i:= 1 to MAX_WAYPOINTS+1 do
 begin
  if i=MAX_WAYPOINTS+1 then
  begin
   result:= -1;
   exit;
  end;
  if not Waypoint[i].Active then break;
 end;
 {i is now the active waypoint}

 Waypoint[i].Active:= true;
 Waypoint[i].X:= sX;
 Waypoint[i].Y:= sY;
 Waypoint[i].id:= i;
 Waypoint[i].ConnectionsNum:= 0;
 Waypoint[i].PathNum:= sPath;

 {activate waypoint}
  result:= i;
end;

end.
